﻿using System;
using System.Diagnostics;
using GHIElectronics.TinyCLR.Devices.Adc;
using GHIElectronics.TinyCLR.Devices.Gpio;
using GHIElectronics.TinyCLR.Devices.Pwm;
using GHIElectronics.TinyCLR.Pins;
using System.Threading;
using Webge.TCLR.Displays;

namespace MiniSerre
{
    class Program
    {
        static void Main()
        {
            // Variables
            // A compléter

            // Création des objets pour une carte FEZ T18
            // Pour une carte FEZ PANDA 3, remplacer FEZ par FEZPandaIII
            //-----------------------------------------------------------------
            // CAN
            var adc = AdcController.GetDefault();
            var potentiometre = adc.OpenChannel(FEZ.AdcChannel.A1); // A connecter sur I1 Tinkerkit
            var CptHumidite = adc.OpenChannel(FEZ.AdcChannel.A0); // A connecter sur I0 Tinkerkit

            // PWM
            var pwm = PwmController.FromName(FEZ.PwmChannel.Controller3.Id); // Connecter ventilateur sur B Ardumoto
            var CdeVentilation = pwm.OpenChannel(FEZ.PwmChannel.Controller3.D11);
            pwm.SetDesiredFrequency(5000);

            // GPIO
            var gpio = GpioController.GetDefault();
            var SENS = gpio.OpenPin(FEZ.GpioPin.D13);
            SENS.SetDriveMode(GpioPinDriveMode.Output);
            SENS.Write(GpioPinValue.Low);
            var Alarme = gpio.OpenPin(FEZ.GpioPin.D5); // A connecter sur O4 Tinkerkit
            Alarme.SetDriveMode(GpioPinDriveMode.Output);
            Alarme.Write(GpioPinValue.Low);

            // Afficheur
            var lcd = new ELCD162(); // A connecter sur Serial Tinkerkit

            // Initialisation
            //-----------------------------------------------------------------
            CdeVentilation.SetActiveDutyCyclePercentage(0);
            CdeVentilation.Start();
            lcd.Init(); lcd.CursorOff();

            while (true)
            {
                // Lire l'humidité
                // A compléter

                // Traiter
                // A compléter

                // Afficher l'humidité et la consigne de vitesse
                lcd.ClearScreen();
                // A compléter
                Thread.Sleep(1000);
            }

        }
    }
}
